#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#pragma comment(lib, "glut32.lib")

#include <windows.h>
#include <stdio.h>

#include <GL/gl.h> // system OpenGL includes
#include <GL/glu.h>
#include <GL/glut.h>

#define SCREEN_WIDTH 600								// We want our screen width 600 pixels
#define SCREEN_HEIGHT 400								// We want our screen height 400 pixels

int dayOfYear;
int mW, mH;
int mButton, mX, mY;
int posX, posY, posZ;


///////////////////////////////// KeyDown Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	This function handles the KeyDown messages, as defined in glutKeyboardFunc() in main().
/////
///////////////////////////////// KeyDown Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
void main_keyboard(unsigned char key, int x, int y)
{
	switch  ( key )
	{
		case 27:
			exit(1);
	}

}


///////////////////////////////// MouseDown Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	This function handles the MouseDown messages, as defined in glutMouseFunc().
/////
///////////////////////////////// MouseDown Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
void mousePress(int button, int state, int x, int y) 
{
	mButton = button;
	mX = x;
	mY = y;
}


///////////////////////////////// MouseMove Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	This function handles the MouseMove messages, as defined in glutMotionFunc().
/////
///////////////////////////////// MouseMove Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
void mouseMove(int x, int y) 
{
	float deltaX = (x - mX);
	float deltaY = -(y - mY);
	
//*******************************************************
//			Navigate the camera using mouse,
//			i.e. to update the values of posX, posY, posZ
//*******************************************************
	switch(mButton) {
		case GLUT_LEFT_BUTTON:
			posX+=deltaX;
			posZ-=deltaY;
			break; 

		case GLUT_MIDDLE_BUTTON:
			posY+=deltaY;
		

		break;  
	}
//*******************************************************
	mX = x;
	mY = y;
}


void drawMain()
{
		dayOfYear++;
		dayOfYear%=366;

		glClearColor(0.0, 0.0, 0.0, 1.0);

		glViewport(0,0,mW,mH);						
		glMatrixMode(GL_PROJECTION);						
		glLoadIdentity();									

		gluPerspective(45.0f,(GLfloat)mW/(GLfloat)mH, 4 , 3000.0f);
		//glOrtho(-100.0f,100.0f,-100.0f,100.0f,0.0f,2000.0f);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

		gluLookAt(posX, posY, posZ, posX, posY, posZ-1, 0, 1, 0);
		glColor3f(1.0, 1.0, 0.0);
		glutSolidSphere(30.0, 20, 20);
				
		glRotatef((float)dayOfYear/366.0*360, 0, 1, 0);
		glTranslatef(100, 0, 0);
		glColor3f(0.0, 0.0, 1.0);
		glutSolidSphere(8.0, 20, 20);

 }


///////////////////////////////// Display and Idle Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
//Event handler when the contents of the window need to be redisplayed,
//as defined in glutDisplayFunc()
//Event handler when no other events are pending,
//as defined in glutIdleFunc() in main()
///////////////////////////////// Display and Idle Event \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
void display(void){
	// clear the rendering window
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	drawMain();
	
	// flush the pipeline, swap the buffers
    glFlush();
    glutSwapBuffers();
}


// initialize OpenGL
void OpenGLInit(void)
{
	glEnable(GL_DEPTH_TEST);							// Enables depth testing
	glEnable(GL_CULL_FACE);								// Turn on back face culling
	
	posX=0;
	posY=0;
	posZ=600;
	
	dayOfYear=0;
}


//Event handler when the window is resized,
//as defined in glutReshapeFunc()
static void ResizeWindow(int w, int h)
{
	if (h == 0)
		h = 1; 

	if (w == 0)
		w = 1;
	
	mW=w;
	mH=h;
}


// main routine
// set up OpenGL, hook up callbacks
// and start the main loop
int main( int argc, char** argv )
{
	// we're going to animate it, so double buffer 
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(SCREEN_WIDTH, SCREEN_HEIGHT);
    glutInitWindowPosition( 50, 50 );

	glutCreateWindow( "GameEngine");

	// Initialize OpenGL as we like it..
    OpenGLInit();
  
	glutReshapeFunc( ResizeWindow );
	glutDisplayFunc( display );

	glutKeyboardFunc( main_keyboard );

	glutMouseFunc( mousePress );
	glutMotionFunc( mouseMove );
	
	// call this when idle
    glutIdleFunc( display );

	// call this in main loop
	glutMainLoop( );

    return(0);
}
